

 package bluetoothtest;

import java.lang.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.bluetooth.*;
import javax.microedition.lcdui.game.GameCanvas;

public class PlayerServer extends BlueTMIDlet {

  public String getImgPath() {
    return "/images/serverPlayer.PNG";
  }
    
    /**
     * Creates a server object. Accepts a single
     * connection from a client and prints the data
     * sent from the client to the screen.
     */
    public void run() {

        try {
            // Make the local device discoverable for the
            // client to locate
            LocalDevice local = LocalDevice.getLocalDevice();
            if (!local.setDiscoverable(DiscoveryAgent.GIAC)) {
                System.out.println("Failed to change to the " +
                    "discoverable mode");
                return;
            }

            // Create a server connection object to accept
            // a connection from a client
            StreamConnectionNotifier notifier =
                (StreamConnectionNotifier)
                Connector.open("btspp://localhost:" +
                    "86b4d249fb8844d6a756ec265dd1f6a3");

            // Accept a connection from the client
            StreamConnection conn = notifier.acceptAndOpen();
            // Open the input to read data from
            InputStream in = conn.openInputStream();
            ByteArrayOutputStream out = new
                ByteArrayOutputStream();

            // Read the data sent from the client until
            // the end of stream
            int data;
            int x=-1;
            int y=-1;
            String buf = "First point: ";
            while ((data = in.read()) != -1) {
                if (x==-1) {
                    x = data;
                    buf += (String.valueOf(x) + ",");
                } else if (y==-1) {
                    //Update
                    y = data;
                    buf += (String.valueOf(y) + ";");
                    getPlayer().setPosition(x, y);
                    gCanvas.redraw();
                    
                    //Output
                    System.out.println(buf);
                    
                    //Reset
                    x = -1;
                    y = -1;
                    buf = "New point: ";
                }
                
                try {
                    Thread.sleep(1);
                } catch (InterruptedException ex) {}
            }
            
            System.out.println("Server closed.");

            // Close all open resources
            in.close();
            conn.close();
            notifier.close();
        } catch (BluetoothStateException e) {
            System.out.println("BluetoothStateException: " + e.getMessage());
        } catch (IOException e) {
            System.out.println("IOException: " + e.getMessage());
        }
    }
}